gtkmm: Gtk::EventControllerKey Class Reference

gtkmm 3.95.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::EventControllerKey Class Reference
Event Controllers and Gestures

Event controller for key press and key release events. More...

`#include <gtkmm/eventcontrollerkey.h>`

Inheritance diagram for Gtk::EventControllerKey:
[legend]

## Public Member Functions
| EventControllerKey (EventControllerKey&& src) noexcept
EventControllerKey& | operator= (EventControllerKey&& src) noexcept
| ~EventControllerKey () noexcept override
GtkEventControllerKey* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventControllerKey* | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventControllerKey* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | forward (Widget& widget)
| Forwards the current event of this controller to a widget. More...
guint | get_group () const
| Gets the key group of the current event of this controller. More...
Widget* | get_focus_origin ()
| Returns the widget that was holding focus before. More...
const Widget* | get_focus_origin () const
| Returns the widget that was holding focus before. More...
Widget* | get_focus_target ()
| Returns the widget that will be holding focus afterwards. More...
const Widget* | get_focus_target () const
| Returns the widget that will be holding focus afterwards. More...
Glib::SignalProxy< bool(guint, guint, Gdk::ModifierType)> | signal_key_pressed ()
Glib::SignalProxy< void(guint, guint, Gdk::ModifierType)> | signal_key_released ()
Glib::SignalProxy< bool(Gdk::ModifierType)> | signal_modifiers ()
Glib::SignalProxy< void()> | signal_im_update ()
Glib::SignalProxy< void(Gdk::CrossingMode, Gdk::NotifyType)> | signal_focus_in ()
Glib::SignalProxy< void(Gdk::CrossingMode, Gdk::NotifyType)> | signal_focus_out ()
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| Whether focus is in the controllers widget itself, as opposed to in a descendent widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_contains_focus () const
| Whether focus is in a descendant of the controllers widget. More...
Public Member Functions inherited from Gtk::EventController
| EventController (EventController&& src) noexcept
EventController& | operator= (EventController&& src) noexcept
| ~EventController () noexcept override
GtkEventController* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEventController* | gobj () const
| Provides access to the underlying C GObject. More...
GtkEventController* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Widget* | get_widget ()
| Returns the Gtk::Widget this controller relates to. More...
const Widget* | get_widget () const
| Returns the Gtk::Widget this controller relates to. More...
bool | handle_event (const Glib::RefPtr< const Gdk::Event >& event)
| Feeds an events into controller, so it can be interpreted and the controller actions triggered. More...
void | reset ()
| Resets the controller to a clean state. More...
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events. More...
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_widget () const
| The widget receiving the Gdk::Events that the controller will handle. More...
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events. More...
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< EventControllerKey > | create ()
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| EventControllerKey ()
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::EventControllerKey > | wrap (GtkEventControllerKey* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Event controller for key press and key release events.

Gtk::EventControllerKey is an event controller meant to handle key press and key release events from keyboards.

Since gtkmm 3.94:

## Constructor & Destructor Documentation

Gtk::EventControllerKey::EventControllerKey | ( | EventControllerKey&& | src | ) |
| noexcept

Gtk::EventControllerKey::~EventControllerKey | ( |  | ) |
| overridenoexcept

Gtk::EventControllerKey::EventControllerKey | ( |  | ) |
| protected

## Member Function Documentation

static Glib::RefPtr<EventControllerKey> Gtk::EventControllerKey::create | ( |  | ) |
| static

bool Gtk::EventControllerKey::forward | ( | Widget& | widget | ) |

Forwards the current event of this controller to a widget.

This function can only be used in handlers for the Gtk::EventControllerKey::signal_key_pressed(), Gtk::EventControllerKey::signal_key_released() or Gtk::EventControllerKey::signal_modifiers() signals.

Parameters

  widget | A Gtk::Widget.

Returns
  Whether the widget handled the event.

Widget* Gtk::EventControllerKey::get_focus_origin | ( |  | ) |

Returns the widget that was holding focus before.

This function can only be used in handlers for the Gtk::EventControllerKey::signal_focus_in() and Gtk::EventControllerKey::signal_focus_out() signals.

Returns
  The previous focus.

const Widget* Gtk::EventControllerKey::get_focus_origin | ( |  | ) | const

Returns the widget that was holding focus before.

This function can only be used in handlers for the Gtk::EventControllerKey::signal_focus_in() and Gtk::EventControllerKey::signal_focus_out() signals.

Returns
  The previous focus.

Widget* Gtk::EventControllerKey::get_focus_target | ( |  | ) |

Returns the widget that will be holding focus afterwards.

This function can only be used in handlers for the Gtk::EventControllerKey::signal_focus_in() and Gtk::EventControllerKey::signal_focus_out() signals.

Returns
  The next focus.

const Widget* Gtk::EventControllerKey::get_focus_target | ( |  | ) | const

Returns the widget that will be holding focus afterwards.

This function can only be used in handlers for the Gtk::EventControllerKey::signal_focus_in() and Gtk::EventControllerKey::signal_focus_out() signals.

Returns
  The next focus.

guint Gtk::EventControllerKey::get_group | ( |  | ) | const

Gets the key group of the current event of this controller.

See gdk_event_get_key_group().

Returns
  The key group.

static GType Gtk::EventControllerKey::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkEventControllerKey* Gtk::EventControllerKey::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkEventControllerKey* Gtk::EventControllerKey::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkEventControllerKey* Gtk::EventControllerKey::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

EventControllerKey& Gtk::EventControllerKey::operator= | ( | EventControllerKey&& | src | ) |
| noexcept

Glib::PropertyProxy_ReadOnly< bool > Gtk::EventControllerKey::property_contains_focus | ( |  | ) | const

Whether focus is in a descendant of the controllers widget.

See Gtk::EventControllerKey::property_is_focus().

When handling focus events, this property is updated before Gtk::EventControllerKey::signal_focus_in() or Gtk::EventControllerKey::signal_focus_out() are emitted.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::EventControllerKey::property_is_focus | ( |  | ) | const

Whether focus is in the controllers widget itself, as opposed to in a descendent widget.

See Gtk::EventControllerKey::property_contains_focus().

When handling focus events, this property is updated before Gtk::EventControllerKey::signal_focus_in() or Gtk::EventControllerKey::signal_focus_out() are emitted.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::SignalProxy<void(Gdk::CrossingMode, Gdk::NotifyType)> Gtk::EventControllerKey::signal_focus_in | ( |  | ) |

Slot Prototype:
  `void on_my_focus_in(Gdk::CrossingMode mode, Gdk::NotifyType detail)`

Flags: Run Last

This signal is emitted whenever the widget controlled by the controller or one of its descendants) is given the keyboard focus.

Parameters

  mode | Crossing mode indicating what caused this change.
  detail | Detail indication where the focus is coming from.

Glib::SignalProxy<void(Gdk::CrossingMode, Gdk::NotifyType)> Gtk::EventControllerKey::signal_focus_out | ( |  | ) |

Slot Prototype:
  `void on_my_focus_out(Gdk::CrossingMode mode, Gdk::NotifyType detail)`

Flags: Run Last

This signal is emitted whenever the widget controlled by the controller (or one of its descendants) loses the keyboard focus.

Parameters

  mode | Crossing mode indicating what caused this change.
  detail | Detail indication where the focus is going.

Glib::SignalProxy<void()> Gtk::EventControllerKey::signal_im_update | ( |  | ) |

Slot Prototype:
  `void on_my_im_update()`

Flags: Run Last

This signal is emitted whenever the input method context filters away a keypress and prevents the controller receiving it. See Gtk::EventControllerKey::set_im_context() and gtk_im_context_filter_keypress().

Glib::SignalProxy<bool(guint, guint, Gdk::ModifierType)> Gtk::EventControllerKey::signal_key_pressed | ( |  | ) |

Slot Prototype:
  `bool on_my_key_pressed(guint keyval, guint keycode, Gdk::ModifierType state)`

Flags: Run Last

This signal is emitted whenever a key is pressed.

Parameters

  keyval | The pressed key.
  keycode | The raw code of the pressed key.
  state | The bitmask, representing the state of modifier keys and pointer buttons. See Gdk::ModifierType.

Returns
  `true` if the key press was handled, `false` otherwise.

Glib::SignalProxy<void(guint, guint, Gdk::ModifierType)> Gtk::EventControllerKey::signal_key_released | ( |  | ) |

Slot Prototype:
  `void on_my_key_released(guint keyval, guint keycode, Gdk::ModifierType state)`

Flags: Run Last

This signal is emitted whenever a key is released.

Parameters

  keyval | The released key.
  keycode | The raw code of the released key.
  state | The bitmask, representing the state of modifier keys and pointer buttons. See Gdk::ModifierType.

Glib::SignalProxy<bool(Gdk::ModifierType)> Gtk::EventControllerKey::signal_modifiers | ( |  | ) |

Slot Prototype:
  `bool on_my_modifiers(Gdk::ModifierType state)`

Flags: Run Last

This signal is emitted whenever the state of modifier keys and pointer buttons change.

Parameters

  state | The bitmask, representing the new state of modifier keys and pointer buttons. See Gdk::ModifierType.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::EventControllerKey > wrap | ( | GtkEventControllerKey * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.